import Vue = require('vue');
export declare class WatchOptions {
    expression: string;
    options: {
        handler: Vue.WatchHandler<Vue>;
    } & Vue.WatchOptions;
}
export declare class VueTypescriptComponentData {
    props: {
        [index: string]: Vue.PropOptions;
    };
    watch: {
        [index: string]: Array<WatchOptions>;
    };
    injected: {
        [index: string]: Object;
    };
}
/** Use field as property
 * If field is initialized, sets default value and type. Otherwise mark as required
 */
export declare function prop(options?: Vue.PropOptions): (target: any, member: string) => void;
/** Ignore field
 * Use on injected fields to make sure they do not appear in data()
 */
export declare function injected(): (target: any, member: string) => void;
/** Use method(val, oldVal) to watch expression
 * The method is still part of the `methods` object and it is possible to use multiple @watch
 * annotations to watch multiple expressions with one function
 */
export declare function watch(expression: string, options?: Vue.WatchOptions): (target: any, member: string) => void;
export interface NoArgumentConstructable {
    new (): any;
    name?: any;
    vueComponentOptions?: Vue.ComponentOptions<Vue>;
}
/** Create property constructor.vueComponentOptions based on method/field annotations
 *  If provided, use options as the base value (.data is always overridden)
 */
export declare function component(options?: Vue.ComponentOptions<Vue>): (cls: NoArgumentConstructable) => void;
